Attribute VB_Name = "AES32"

'
' AES32.BAS [AES 6.0 for Visual Basic]
'

Declare Function aesAttach Lib "AES32.DLL" (ByVal KeyCode As Long,ByVal Flags As Long) As Long
Declare Function aesByteToHex Lib "AES32.DLL" (ByVal Buffer As String,ByVal BufLen As Long,ByVal HexBuf As String) As Long
Declare Function aesDecodeBase64 Lib "AES32.DLL"(ByVal CodeBuf As String,ByVal CodeLen As Long,ByVal DataBuf As String) As Long
Declare Function aesDecryptBlocks Lib "AES32.DLL" (ByVal Control As String,ByVal Data As String,ByVal DataLen As Long,ByVal Buffer As String) As Long 
Declare Function aesDecryptBuffer Lib "AES32.DLL" (ByVal Control As String,ByVal InputBuf As String,ByVal InputLen As Long,ByVal OutputBuf As String) As Long
Declare Function aesDecryptFile Lib "AES32.DLL" (ByVal Control As String,ByVal InputFile As String,ByVal OutputFile As String) As Long
Declare Function aesEncodeBase64 Lib "AES32.DLL"(ByVal DataBuf As String,ByVal DataLen As Long,ByVal CodeBuf As String) As Long
Declare Function aesEncryptBlocks Lib "AES32.DLL" (ByVal Control As String,ByVal Data As String,ByVal DataLen As Long,ByVal Buffer As String) As Long 
Declare Function aesEncryptBuffer Lib "AES32.DLL" (ByVal Control As String,ByVal InputBuf As String,ByVal InputLen As Long,ByVal OutputBuf As String) As Long
Declare Function aesEncryptFile Lib "AES32.DLL" (ByVal Control As String,ByVal InputFile As String,ByVal OutputFile As String) As Long
Declare Function aesEncryptWrite Lib "AES32.DLL" (ByVal Control As String,ByVal Data As String,ByVal DataLen As Long,ByVal OutputFile As String) As Long    
Declare Function aesErrorText Lib "AES32.DLL" (ByVal ErrCode As Long,ByVal Buffer As String,ByVal BufLen As Long) As Long
Declare Function aesGetInteger Lib "AES32.DLL" (ByVal Control As String,ByVal ParamName As Long) As Long
Declare Function aesGetString Lib "AES32.DLL" (ByVal Control As String,ByVal ParamName As Long,ByVal Buffer As String,ByVal BufLen As Long) As Long
Declare Function aesHexToByte Lib "AES32.DLL" (ByVal HexBuf As String,ByVal HexBytes As Long,ByVal ByteBuf As String) As Long
Declare Function aesInitAES Lib "AES32.DLL" (ByVal KeyBuf As String,ByVal iVector As String,ByVal Mode As Long,ByVal Direction As Long,ByVal Control As String) As Long
Declare Function aesMakeKeyPair Lib "AES32.DLL" (ByVal PublicKey As String, ByVal PrivateKey As String) As Long
Declare Function aesMakeRandom Lib "AES32.DLL" (ByVal Buffer As String,ByVal BufSize As Long) As Long
Declare Function aesMakeSharedKey Lib "AES32.DLL" (ByVal PublicKey As String, ByVal PrivateKey As String, ByVal SharedKey As String, ByVal AES_KEY As String) As Integer
Declare Function aesMakeUserKey Lib "AES32.DLL" (ByVal UserPhrase As String,ByVal KeyBuffer As String,ByVal Flags As Long) As Long  
Declare Function aesPadBuffer Lib "AES32.DLL" (ByVal Buffer As String,ByVal BufLen As Long,ByVal PadControl As Long) As Long
Declare Function aesReadDecrypt Lib "AES32.DLL" (ByVal Control As String,ByVal InputFile As String,ByVal Buffer As String,ByVal BufLen As Long) As Long
Declare Function aesRemovePad Lib "AES32.DLL" (ByVal DataBuf As String,ByVal DataLen As Long) As Long
Declare Function aesSaltPass Lib "AES32.DLL" (ByVal SaltSeed As Long,ByVal NbrSaltChars As Long,ByVal SaltOut As String,ByVal PassInp As String,ByVal PassOut As String) As Long
Declare Function aesSecureRandom Lib "AES32.DLL" (ByVal Context As String,ByVal Buffer As String,ByVal BufSize As Long) As Long
Declare Function aesSetInteger Lib "AES32.DLL"(ByVal Control As String,ByVal ParamName As Long,ByVal ParamValue As Long) As Long
Declare Function aesSha256 Lib "AES32.DLL" (ByVal Data As String,ByVal Hash As String) As Long
Declare Function aesSha256Data Lib "AES32.DLL" (ByVal Data As String,ByVal Length As Long,ByVal Hash As String) As Long
Declare Function aesSha256File Lib "AES32.DLL" (ByVal FileName As String,ByVal Hash As String) As Long
Declare Function aesShredFile Lib "AES32.DLL" (ByVal File As String,ByVal DelFlag As Long) As Long
Declare Function aesSleep Lib "AES32.DLL" (ByVal MilliSecs As Long) As Long
Declare Function aesVerifyControl Lib "AES32.DLL" (ByVal Control As String) As Long
Declare Function aesXorBits Lib "AES32.DLL" (ByVal XorBuf As String,ByVal XorLen As Long,ByVal InBuf As String,ByVal OutBuf As String,ByVal BufLen As Long) As Long

Global Const AES_BLOCK_SIZE          As Integer =  16 ' block size of AES is fixed at 16 bytes
Global Const AES_KEY_SIZE            As Integer =  32 ' key size is always 32 bytes (for 256-bit AES)
Global Const AES_GET_CONTROL_VERSION As Integer = 101 ' get AES control block version
Global Const AES_GET_CONTROL_SIZE    As Integer = 102 ' get size of control block
Global Const AES_GET_VERSION         As Integer = 103 ' get AES version
Global Const AES_GET_BUILD           As Integer = 104 ' get AES build
Global Const AES_GET_SECURE_SIZE     As Integer = 105 ' get size of secure random control block
Global Const AES_GET_REGISTRATION    As Integer = 201 ' get registration string
Global Const AES_SET_PAD_BYTE        As Integer = 301 ' set padding
Global Const AES_ECB_MODE            As Integer =   0 ' use ECB mode (default)
Global Const AES_CBC_MODE            As Integer =   2 ' use CBC mode
Global Const AES_ENCRYPT             As Integer =   0 ' encrypt (default)
Global Const AES_DECRYPT             As Integer =   4 ' decrypt
Global Const AES_PAD_ZERO            As Integer =   6 ' pad with 0's
Global Const AES_PAD_SPACE           As Integer =   7 ' pad with spaces (0x20)
Global Const AES_PAD_RANDOM          As Integer =   8 ' pad with random values
Global Const AES_PAD_PKCS7           As Integer =   9 ' pad according to PKCS7
Global Const AES_NIBBLE_METHOD       As Integer =   0 ' use "nibble" method to create encryption key
Global Const AES_SHA256_METHOD       As Integer =   1 ' use SHA 256 to create encryption key
Global Const AES_MIXED_METHOD        As Integer =   2 ' do nibble method followed by SHA256 method
Global Const AES_PKCS7_MASK          As Integer =   1 ' use PKCS7 padding
Global Const AES_HEADER_MASK         As Integer =   2 ' write file header bytes if bit = 1
Global Const AES_SET_SEED            As Integer =   1 ' set random number generator seed

'  error codes
Global Const AES_NOT_MULTIPLE        As Integer =  -2 ' not multiple of 16 bytes
Global Const AES_BAD_KEY_DIR         As Integer =  -3 ' key direction is invalid
Global Const AES_BAD_KEY_DATA        As Integer =  -4 ' key data is invalid
Global Const AES_BAD_CIPHER_MODE     As Integer =  -5 ' invalid cipher mode
Global Const AES_BAD_CIPHER_STATE    As Integer =  -6 ' cipher not initialized
Global Const AES_BAD_BLOCK_LENGTH    As Integer =  -7 ' invalid block length
Global Const AES_NOT_INITIALIZED     As Integer =  -8 ' AES control block not initialized
Global Const AES_IS_CORRUPTED        As Integer =  -9 ' AES control block is corrupted
Global Const AES_INTERNAL_ERROR      As Integer = -10 ' AES internal error
Global Const AES_BAD_PASS_LEN        As Integer = -11 ' password too short
Global Const AES_CANNOT_OPEN         As Integer = -12 ' cannot open file (for read)
Global Const AES_CANNOT_CREATE       As Integer = -13 ' cannot create file
Global Const AES_READ_ERROR          As Integer = -14 ' read error
Global Const AES_WRITE_ERROR         As Integer = -15 ' write error
Global Const AES_BAD_PAD_CHOICE      As Integer = -16 ' must be AES_PAD_*
Global Const AES_BAD_HEX_CHAR        As Integer = -17 ' bad hex character
Global Const AES_UNEXPECTED_CHAR     As Integer = -18 ' unexpected character
Global Const AES_ATTACH_CALL         As Integer = -19 ' aesAttach() not called
Global Const AES_NULL_POINTER        As Integer = -20 ' unexpected null pointer
Global Const AES_BAD_METHOD          As Integer = -21 ' bad method
Global Const AES_BUFFER_TOO_SMALL    As Integer = -22 ' buffer is too small
Global Const AES_BUFFER_TOO_BIG      As Integer = -23 ' buffer is too big
Global Const AES_PKCS7_ERROR         As Integer = -24 ' PKCS7 padding error
Global Const AES_CANNOT_OPEN_WRITE   As Integer = -25 ' cannot open file (for write)
Global Const AES_CANNOT_CLOSE        As Integer = -26 ' cannot close file
Global Const AES_CANNOT_DELETE       As Integer = -27 ' cannot delete file
Global Const AES_ABORTED             As Integer = (-201)
Global Const AES_KEYCODE             As Integer = (-202)
Global Const AES_EXPIRED             As Integer = (-203)
