Module aes64

'
' AES64.VB [AES 6.0 for Visual Basic]
'

Declare Function aesAttach Lib "AES64.DLL" (ByVal KeyCode As Integer, ByVal Flags As Integer) As Integer
Declare Function aesByteToHex Lib "AES64.DLL" (ByVal Buffer As String, ByVal BufLen As Integer, ByVal HexBuf As String) As Integer
Declare Function aesDecodeBase64 Lib "AES64.DLL"(ByVal CodeBuf As String,ByVal CodeLen As Integer,ByVal DataBuf As String) As Integer
Declare Function aesDecryptBlocks Lib "AES64.DLL" (ByVal Control As String,ByVal Data As String,ByVal DataLen As Integer,ByVal Buffer As String) As Integer 
Declare Function aesDecryptBuffer Lib "AES64.DLL" (ByVal Control As String,ByVal InputBuf As String,ByVal InputLen As Integer,ByVal OutputBuf As String) As Integer
Declare Function aesDecryptFile Lib "AES64.DLL" (ByVal Control As String, ByVal InputFile As String, ByVal OutputFile As String) As Integer
Declare Function aesEncodeBase64 Lib "AES64.DLL"(ByVal DataBuf As String,ByVal DataLen As Integer,ByVal CodeBuf As String) As Integer
Declare Function aesEncryptBlocks Lib "AES64.DLL" (ByVal Control As String,ByVal Data As String,ByVal DataLen As Integer,ByVal Buffer As String) As Integer 
Declare Function aesEncryptBuffer Lib "AES64.DLL" (ByVal Control As String,ByVal InputBuf As String,ByVal InputLen As Integer,ByVal OutputBuf As String) As Integer
Declare Function aesEncryptFile Lib "AES64.DLL" (ByVal Control As String, ByVal InputFile As String, ByVal OutputFile As String) As Integer
Declare Function aesEncryptWrite Lib "AES64.DLL"(ByVal Control As String,ByVal Data As String,ByVal DataLen As Integer, ByVal OutputFile As String) As Integer    
Declare Function aesErrorText Lib "AES64.DLL" (ByVal ErrCode As Integer, ByVal Buffer As String,ByVal BufLen As Integer) As Integer
Declare Function aesGetInteger Lib "AES64.DLL" (ByVal Control As String, ByVal ParamName As Integer) As Integer
Declare Function aesGetString Lib "AES64.DLL" (ByVal Control As String, ByVal ParamName As Integer, ByVal Buffer As String, ByVal BufLen As Integer) As Integer
Declare Function aesHexToByte Lib "AES64.DLL" (ByVal HexBuf As String, ByVal HexBytes As Integer, ByVal ByteBuf As String) As Integer
Declare Function aesInitAES Lib "AES64.DLL" (ByVal KeyBuf As String, ByVal Vector As String, ByVal Mode As Integer, ByVal Direction As Integer, ByVal Control As String) As Integer
Declare Function aesMakeKeyPair Lib "AES64.DLL" (ByVal PublicKey As String, ByVal PrivateKey As String) As Integer
Declare Function aesMakeRandom Lib "AES64.DLL" (ByVal Buffer As String, ByVal BufSize As Integer) As Integer
Declare Function aesMakeSharedKey Lib "AES64.DLL" (ByVal PublicKey As String, ByVal PrivateKey As String, ByVal SharedKey As String, ByVal AES_KEY As String) As Integer
Declare Function aesMakeUserKey Lib "AES64.DLL" (ByVal UserPhrase As String, ByVal KeyBuffer As String, ByVal Flags As Integer) As Integer  
Declare Function aesPadBuffer Lib "AES64.DLL" (ByVal Buffer As String,ByVal BufLen As Integer,ByVal PadControl As Integer) As Integer
Declare Function aesReadDecrypt Lib "AES64.DLL" (ByVal Control As String,ByVal InputFile As String,ByVal Buffer As String,ByVal BufLen As Integer) As Integer
Declare Function aesRemovePad Lib "AES64.DLL" (ByVal DataBuf As String,ByVal DataLen As Integer) As Integer
Declare Function aesSaltPass Lib "AES64.DLL" (ByVal SaltSeed As Integer,ByVal NbrSaltChars As Integer,ByVal SaltOut As String,ByVal PassInp As String,ByVal PassOut As String) As Integer
Declare Function aesSecureRandom Lib "AES64.DLL" (ByVal Context As String, ByVal Buffer As String, ByVal BufSize As Integer) As Integer
Declare Function aesSetInteger Lib "AES64.DLL"(ByVal Control As String, ByVal ParamName As Integer, ByVal ParamValue As Integer) As Integer
Declare Function aesSha256 Lib "AES64.DLL" (ByVal Data As String, ByVal Hash As String) As Integer
Declare Function aesSha256Data Lib "AES64.DLL" (ByVal Data As String, ByVal Length As Integer, ByVal Hash As String) As Integer
Declare Function aesSha256File Lib "AES64.DLL" (ByVal FileName As String, ByVal Hash As String) As Integer
Declare Function aesShredFile Lib "AES64.DLL" (ByVal File As String, ByVal DelFlag As Integer) As Integer
Declare Function aesSleep Lib "AES64.DLL" (ByVal MilliSecs As Integer) As Integer
Declare Function aesVerifyControl Lib "AES64.DLL" (ByVal Control As String) As Integer
Declare Function aesXorBits Lib "AES64.DLL" (ByVal XorBuf As String,ByVal XorLen As Integer, ByVal InBuf As String, ByVal OutBuf As String, ByVal BufLen As Integer) As Integer

Public Const AES_BLOCK_SIZE          As Integer =  16 ' block size of AES is fixed at 16 bytes
Public Const AES_KEY_SIZE            As Integer =  32 ' key size is always 32 bytes (for 256-bit AES)
Public Const AES_GET_CONTROL_VERSION As Integer = 101 ' get AES control block version
Public Const AES_GET_CONTROL_SIZE    As Integer = 102 ' get size of control block
Public Const AES_GET_VERSION         As Integer = 103 ' get AES version
Public Const AES_GET_BUILD           As Integer = 104 ' get AES build
Public Const AES_GET_SECURE_SIZE     As Integer = 105 ' get size of secure random control block
Public Const AES_GET_REGISTRATION    As Integer = 201 ' get registration string
Public Const AES_SET_PAD_BYTE        As Integer = 301 ' set padding
Public Const AES_ECB_MODE            As Integer =   0 ' use ECB mode (default)
Public Const AES_CBC_MODE            As Integer =   2 ' use CBC mode
Public Const AES_ENCRYPT             As Integer =   0 ' encrypt (default)
Public Const AES_DECRYPT             As Integer =   4 ' decrypt
Public Const AES_PAD_ZERO            As Integer =   6 ' pad with 0's
Public Const AES_PAD_SPACE           As Integer =   7 ' pad with spaces (0x20)
Public Const AES_PAD_RANDOM          As Integer =   8 ' pad with random values
Public Const AES_PAD_PKCS7           As Integer =   9 ' pad according to PKCS7
Public Const AES_NIBBLE_METHOD       As Integer =   0 ' use "nibble" method to create encryption key
Public Const AES_SHA256_METHOD       As Integer =   1 ' use SHA 256 to create encryption key
Public Const AES_MIXED_METHOD        As Integer =   2 ' do nibble method followed by SHA256 method
Public Const AES_PKCS7_MASK          As Integer =   1 ' use PKCS7 padding
Public Const AES_HEADER_MASK         As Integer =   2 ' write file header bytes if bit = 1
Public Const AES_SET_SEED            As Integer =   1 ' set random number generator seed

'  error codes

Public Const AES_NOT_MULTIPLE        As Integer =  -2 ' not multiple of 16 bytes
Public Const AES_BAD_KEY_DIR         As Integer =  -3 ' key direction is invalid
Public Const AES_BAD_KEY_DATA        As Integer =  -4 ' key data is invalid
Public Const AES_BAD_CIPHER_MODE     As Integer =  -5 ' invalid cipher mode
Public Const AES_BAD_CIPHER_STATE    As Integer =  -6 ' cipher not initialized
Public Const AES_BAD_BLOCK_LENGTH    As Integer =  -7 ' invalid block length
Public Const AES_NOT_INITIALIZED     As Integer =  -8 ' AES control block not initialized
Public Const AES_IS_CORRUPTED        As Integer =  -9 ' AES control block is corrupted
Public Const AES_INTERNAL_ERROR      As Integer = -10 ' AES internal error
Public Const AES_BAD_PASS_LEN        As Integer = -11 ' password too short
Public Const AES_CANNOT_OPEN         As Integer = -12 ' cannot open file (for read)
Public Const AES_CANNOT_CREATE       As Integer = -13 ' cannot create file
Public Const AES_READ_ERROR          As Integer = -14 ' read error
Public Const AES_WRITE_ERROR         As Integer = -15 ' write error
Public Const AES_BAD_PAD_CHOICE      As Integer = -16 ' must be AES_PAD_*
Public Const AES_BAD_HEX_CHAR        As Integer = -17 ' bad hex character
Public Const AES_UNEXPECTED_CHAR     As Integer = -18 ' unexpected character
Public Const AES_ATTACH_CALL         As Integer = -19 ' aesAttach() not called
Public Const AES_NULL_POINTER        As Integer = -20 ' unexpected null pointer
Public Const AES_BAD_METHOD          As Integer = -21 ' bad method
Public Const AES_BUFFER_TOO_SMALL    As Integer = -22 ' buffer is too small 
Public Const AES_BUFFER_TOO_BIG      As Integer = -23 ' buffer is too big
Public Const AES_PKCS7_ERROR         As Integer = -24 ' PKCS7 padding error
Public Const AES_CANNOT_OPEN_WRITE   As Integer = -25 ' cannot open file (for write)
Public Const AES_CANNOT_CLOSE        As Integer = -26 ' cannot close file
Public Const AES_CANNOT_DELETE       As Integer = -27 ' cannot delete file

Public Const AES_ABORTED             As Integer = (-201)
Public Const AES_KEYCODE             As Integer = (-202)
Public Const AES_EXPIRED             As Integer = (-203)

End Module



